scala.tools.nsc.ast.Trees

# treeInfo

###
Related Doc: package Trees

#### object treeInfo extends TreeInfo

Source
  Trees.scala

Linear Supertypes
TreeInfo, reflect.internal.TreeInfo, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. treeInfo
2. TreeInfo
3. TreeInfo
4. AnyRef
5. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### class Applied extends AnyRef

   Definition Classes
     TreeInfo

2. #### class DynamicApplicationExtractor extends AnyRef

   Definition Classes
     TreeInfo

3. #### abstract class SeeThroughBlocks[T] extends AnyRef

   Definition Classes
     TreeInfo

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### object Applied

   Definition Classes
     TreeInfo

5. #### object AsInstanceOf

   Definition Classes
     TreeInfo

6. #### object BinaryOp

   Definition Classes
     TreeInfo

7. #### object DynamicApplication extends DynamicApplicationExtractor

   Definition Classes
     TreeInfo

8. #### object DynamicApplicationNamed extends DynamicApplicationExtractor

   Definition Classes
     TreeInfo

9. #### object DynamicUpdate extends DynamicApplicationExtractor

   Definition Classes
     TreeInfo

10. #### object IsFalse extends SeeThroughBlocks[Boolean]

    Definition Classes
      TreeInfo

11. #### object IsTrue extends SeeThroughBlocks[Boolean]

    Definition Classes
      TreeInfo

12. #### object MacroImplReference

    Definition Classes
      TreeInfo

13. #### final val SYNTH_CASE_FLAGS: Int(2099200)

    Definition Classes
      TreeInfo

14. #### object StripCast

    Definition Classes
      TreeInfo

15. #### object TypeApplyOp

    Definition Classes
      TreeInfo

16. #### object Unapplied

    Definition Classes
      TreeInfo

17. #### object ValueClass

    Definition Classes
      TreeInfo

18. #### object WildcardStarArg

    Definition Classes
      TreeInfo

19. #### def admitsTypeSelection(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

20. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

21. #### def assignmentToMaybeNamedArg(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

22. #### def catchesThrowable(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

23. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

24. #### def dissectApplied(tree: Global.Tree): Applied

    Definition Classes
      TreeInfo

25. #### def effectivePatternArity(args: List[Global.Tree]): Int

    Definition Classes
      TreeInfo

26. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

28. #### def firstConstructor(stats: List[Global.Tree]): Global.Tree

    Definition Classes
      TreeInfo

29. #### def firstConstructorArgs(stats: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      TreeInfo

30. #### def firstDefinesClassOrObject(trees: List[Global.Tree], name: Global.Name): Boolean

    Definition Classes
      TreeInfo

31. #### def flattenedPatternArgs(args: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      TreeInfo

32. #### def foreachMethodParamAndArg(params: List[Global.Symbol], args: List[Global.Tree])(f: (Global.Symbol, Global.Tree) ⇒ Unit): Boolean

    Definition Classes
      TreeInfo

33. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

34. #### val global: Trees.this.type

    Definition Classes
      treeInfo → TreeInfo → TreeInfo

35. #### def hasSynthCaseSymbol(t: Global.Tree): Boolean

    Definition Classes
      TreeInfo

36. #### def hasUntypedPreSuperFields(stats: List[Global.Tree]): Boolean

    Definition Classes
      TreeInfo

37. #### def hasVolatileType(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

38. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()

39. #### def isAbsTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

40. #### def isAliasTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

41. #### def isApplyDynamicName(name: Global.Name): Boolean

    Definition Classes
      TreeInfo

42. #### def isByNameParamType(tpt: Global.Tree): Boolean

    Definition Classes
      TreeInfo

43. #### def isCatchCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

44. #### def isConstructorWithDefault(t: Global.Tree): Boolean

    Definition Classes
      TreeInfo → TreeInfo

45. #### def isDeclarationOrTypeDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

46. #### def isDefaultCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

47. #### def isDefaultGetter(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

48. #### def isEarlyDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

49. #### def isEarlyValDef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

50. #### def isExprSafeToInline(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

51. #### def isGuardedCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

52. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

53. #### def isInterfaceMember(tree: Global.Tree): Boolean

    Is tree legal as a member definition of an interface?

    Is tree legal as a member definition of an interface?

    Definition Classes
      TreeInfo → TreeInfo

54. #### def isLeftAssoc(operator: Global.Name): Boolean

    Definition Classes
      TreeInfo

55. #### def isMacroApplication(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

56. #### def isMacroApplicationOrBlock(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

57. #### def isNullaryInvocation(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

58. #### def isPath(tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

59. #### def isPureDef(tree: Global.Tree): Boolean

    Is tree a pure (i.e.

    Is tree a pure (i.e. non-side-effecting) definition?

    Definition Classes
      TreeInfo → TreeInfo

60. #### def isPureExprForWarningPurposes(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

61. #### def isQualifierSafeToElide(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

62. #### def isRepeatedParamType(tpt: Global.Tree): Boolean

    Definition Classes
      TreeInfo

63. #### def isSelfConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

64. #### def isSelfOrSuperConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

65. #### def isSequenceValued(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

66. #### def isStableIdentifier(tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

67. #### def isStableIdentifierPattern(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

68. #### def isStableMemberOf(sym: Global.Symbol, tree: Global.Tree, allowVolatile: Boolean): Boolean

    Definition Classes
      TreeInfo

69. #### def isStar(x: Global.Tree): Boolean

    Definition Classes
      TreeInfo

70. #### def isSuperConstrCall(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

71. #### def isSwitchAnnotation(tpe: Global.Type): Boolean

    Definition Classes
      TreeInfo

72. #### def isSynthCaseSymbol(sym: Global.Symbol): Boolean

    Definition Classes
      TreeInfo

73. #### def isSyntheticCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

74. #### def isSyntheticDefaultCase(cdef: Global.CaseDef): Boolean

    Definition Classes
      TreeInfo

75. #### def isTraitRef(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

76. #### def isVarPattern(pat: Global.Tree): Boolean

    Definition Classes
      TreeInfo

77. #### def isVarPatternDeep(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

78. #### def isVariableOrGetter(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

79. #### def isWildcardArg(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

80. #### def isWildcardStarArg(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

81. #### def isWildcardStarArgList(trees: List[Global.Tree]): Boolean

    Definition Classes
      TreeInfo

82. #### def isWildcardStarType(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

83. #### def mapMethodParamsAndArgs[R](params: List[Global.Symbol], args: List[Global.Tree])(f: (Global.Symbol, Global.Tree) ⇒ R): List[R]

    Definition Classes
      TreeInfo

84. #### def mayBeTypePat(tree: Global.Tree): Boolean

    Definition Classes
      TreeInfo

85. #### def mayBeVarGetter(sym: Global.Symbol): Boolean

    Definition Classes
      TreeInfo

86. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

87. #### def noPredefImportForUnit(body: Global.Tree): Boolean

    Definition Classes
      TreeInfo

88. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

89. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

90. #### def preSuperFields(stats: List[Global.Tree]): List[Global.ValDef]

    Definition Classes
      TreeInfo

91. #### def stripCast(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

92. #### def stripNamedApplyBlock(tree: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

93. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

94. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

95. #### def typeParameters(tree: Global.Tree): List[Global.TypeDef]

    Definition Classes
      TreeInfo

96. #### def unbind(x: Global.Tree): Global.Tree

    Definition Classes
      TreeInfo

97. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

98. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

99. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from TreeInfo

### Inherited from reflect.internal.TreeInfo

### Inherited from AnyRef

### Inherited from Any

### Ungrouped